/*****************************************************************************

	Projet	: RYasmin

	Fichier	:	YasminBeIdeAddOn.cpp
	Partie	: -

	Auteur	: RM
	Date		: 010597
	Format	: tabs==2

	Based on "Commenter" add-on sample code by MW for BeIDE 1.2.

*****************************************************************************/

#include "MTextAddOn.h"

#pragma export on
extern "C"
{
	long perform_edit(MTextAddOn *addon);
}
#pragma export reset


// Private prototypes
long AddComments(MTextAddOn *addon);
long RemoveComments(MTextAddOn *addon);

const unsigned char RETURN_CHAR = 10;


//**********************************
long perform_edit(MTextAddOn *addon)
//**********************************
/*
	Public interface for the add-on
*/
{
long selStart;
long selEnd;

	//  error checking
	addon->GetSelection(&selStart, &selEnd);
	if (selEnd < selStart) return B_ERROR;

	if (selEnd == selStart)
	{
		// no selection ? use all text
		selStart = 0;
		selEnd = addon->TextLength();
	}

	//  set-up

char *txt = (char *)addon->Text();
char *ptr = txt + selStart;
char *end = txt + selEnd;

	// launch Yasmin Robot, if available
long error;
team_id tid;
BMessenger *post;
BMessage *msg;
char a;

#define K_YASMIN_NAME					"RYasmin"
#define K_YASMIN_SIG					'YaSm'
#define K_YASMIN_SCRIPT_SIG		'YASm'
#define K_YASMIN_SCRIPT_NAME	"script"

	try
	{
		// is Yasmin running ?
		tid = be_roster->TeamFor(K_YASMIN_SIG);
		if (tid == B_ERROR)
		{
			// no, then launch
			error = be_roster->Launch(K_YASMIN_SIG, (BMessage *)NULL, &tid);
			if (error < B_NO_ERROR) throw("Can't launch Yasmin application !");
		}

		post = new BMessenger(K_YASMIN_SIG, tid);
		if (!post) throw("Alloc error for BMessenger.");
		if (post->Error() != B_NO_ERROR) throw("Error building BMessenger !");

		// build a message with the same signature than script files
		msg = new BMessage(K_YASMIN_SCRIPT_SIG);
		if (!msg) throw("Alloc error for BMessage.");

		// add a string called "script" with the asciiz text
		// ugly hack here -- sorry, Jon !
		if ((a = *end) != '\0') *end='\0';
		msg->AddString(K_YASMIN_SCRIPT_NAME, ptr);
		if (a != '\0') *end=a;
		post->SendMessage(msg);
		
		delete post;
	}
	catch(char *serr)
	{
		BAlert *box;
		char s[512];
		sprintf(s, "Yasmin add-on for BeIDE\ndev release : 0.01d - May 97\n"
							 "\nError : %s\n"
							 "\n R'alf\nContact : raphael.moll@inforoute.cgs.fr",
							 serr);
		
		box = new BAlert(	"Yasmin - Error", s ,"    OK    ", NULL, NULL,
											B_WIDTH_FROM_WIDEST, B_STOP_ALERT);
		if (box) box->Go();
	}
	catch(...)
	{
		BAlert *box;
		
		box = new BAlert(	"Yasmin - Error",
											"Yasmin add-on for BeIDE\ndev release : 0.01d - May 97\n"
							 				"\Unexpected exception\n"
							 				"\n R'alf\nContact : raphael.moll@inforoute.cgs.fr"
											,"    OK    ", NULL, NULL,
											B_WIDTH_FROM_WIDEST, B_STOP_ALERT);
		if (box) box->Go();
	}

	return B_NO_ERROR;
}


// eoc
